// IBPS Jobmanager Version 1.0
// JS-Code fr Kalenderfenster
// Last Update: 24.06.2002
// Author(s): Ralf Friedrichs


// months as they appear in the calendar's title
var ARR_MONTHS = ["Januar", "Februar", "Mrz", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember"];
// week day titles as they appear on the calendar
var ARR_WEEKDAYS = ["So", "Mo", "Di", "Mi", "Do", "Fr", "Sa"];
// day week starts from (normally 0-Mo or 1-Su)
var NUM_WEEKSTART = 1;
// path to the directory where calendar images are stored. trailing slash req.
var STR_ICONPATH = '/jobmanager/images/';

var calendars = [];

function calendar1(obj_target) {

	// assing methods
	this.gen_date = cal_gen_date1;
	this.prs_date = cal_prs_date1;
	this.popup    = cal_popup1;

	// validate input parameters
	if (!obj_target)
		return alert("Error calling the calendar: no target control specified");
	if (obj_target.value == null)
		return alert("Error calling the calendar: parameter specified is not valid target control");
	this.target = obj_target;
	// register in global collections
	this.id = calendars.length;
	calendars[this.id] = this;
}

function cal_popup1 (str_datetime) {

	this.dt_current = this.prs_date(str_datetime ? str_datetime : this.target.value);
	if (!this.dt_current) return alert("Unknown datetime format: '" + str_datetime + "'.");

	// get same date in the previous year
	var dt_prev_year = new Date(this.dt_current);
	dt_prev_year.setFullYear(dt_prev_year.getFullYear() - 1);
	if (dt_prev_year.getDate() != this.dt_current.getDate())
		dt_prev_year.setDate(0);
	
	// get same date in the next year
	var dt_next_year = new Date(this.dt_current);
	dt_next_year.setFullYear(dt_next_year.getFullYear() + 1);
	if (dt_next_year.getDate() != this.dt_current.getDate())
		dt_next_year.setDate(0);

	// get same date in the previous month
	var dt_prev_month = new Date(this.dt_current);
	dt_prev_month.setMonth(dt_prev_month.getMonth() - 1);
	if (dt_prev_month.getDate() != this.dt_current.getDate())
		dt_prev_month.setDate(0);
	
	// get same date in the next month
	var dt_next_month = new Date(this.dt_current);
	dt_next_month.setMonth(dt_next_month.getMonth() + 1);
	if (dt_next_month.getDate() != this.dt_current.getDate())
		dt_next_month.setDate(0);
	
	// get first day to display in the grid for current month
	var dt_firstday = new Date(this.dt_current);
	dt_firstday.setDate(1);
	dt_firstday.setDate(1 - (7 + dt_firstday.getDay() - NUM_WEEKSTART) % 7);
	
	// html generation (feel free to tune it for your particular application)
	// print calendar header
	var obj_calwindow = window.open("", "Calendar", "width=210,height=200,status=no,resizable=no,top=200,left=200");
	obj_calwindow.opener = window;

	var str_buffer = new String (
	'<HTML>'+
	'<HEAD>'+
		'<TITLE>Datumsauswahl</TITLE>'+
        '<LINK REL="STYLESHEET" TYPE="text/css" HREF="/jobmanager/schriften.css">'+
		'<SCRIPT language="JavaScript">'+
		'function set_datetime(n_datetime, b_close) {'+
			'var obj_calendar = window.opener.calendars['+this.id+'];'+
			'obj_calendar.target.value = obj_calendar.gen_date(new Date(n_datetime));'+
			'if (b_close) window.close();'+
			'else obj_calendar.popup(n_datetime);'+
		'}'+
		'</script>'+
	'</head>'+
	'<body bgcolor="#FFFFFF">'+
	'<table class="clsOTable" cellspacing="0" border="0" width="100%">'+
	'<tr><td bgcolor="#0074C5">'+
	'<table cellspacing="1" cellpadding="3" border="0" width="100%">'+
	'<tr>'+
		'<td bgcolor="#0074C5"><a href="javascript:set_datetime('+dt_prev_year.valueOf()+')"><img src="'+STR_ICONPATH+'icon_prev-year.gif" width="19" height="17" border="0" alt="vorheriges Jahr"></a></td>'+
		'<td bgcolor="#0074C5"><a href="javascript:set_datetime('+dt_prev_month.valueOf()+')"><img src="'+STR_ICONPATH+'icon_prev-month.gif" width="11" height="17" border="0" alt="vorheriger Monat"></a></td>'+
		'<td bgcolor="#0074C5" colspan="3" align="center" CLASS="TextWeissKleinFett">'+ARR_MONTHS[this.dt_current.getMonth()]+' '+this.dt_current.getFullYear()+'</td>'+
		'<td bgcolor="#0074C5" align="right"><a href="javascript:set_datetime('+dt_next_month.valueOf()+')"><img src="'+STR_ICONPATH+'icon_next-month.gif" width="11" height="17" border="0" alt="nchster Monat"></a></td>'+
		'<td bgcolor="#0074C5" align="right"><a href="javascript:set_datetime('+dt_next_year.valueOf()+')"><img src="'+STR_ICONPATH+'icon_next-year.gif" width="19" height="17" border="0" alt="nchstes Jahr"></a></td>'+
	'</tr><tr>');
	var dt_current_day = new Date(dt_firstday);

	// print weekdays titles
	for (var n=0; n<7; n++)
		str_buffer += '<TD BGCOLOR="#FFFF99" ALIGN="center" CLASS="TextBlau">'+ARR_WEEKDAYS[(NUM_WEEKSTART+n)%7]+'</TD>';
	str_buffer += '</TR>';

	// print calendar table
	var dt_current_day = new Date(dt_firstday);
	while (dt_current_day.getMonth() == this.dt_current.getMonth() || dt_current_day.getMonth() == dt_firstday.getMonth()) {
      // print row heder
      str_buffer += '<TR>';
      for (var n_current_wday=0; n_current_wday<7; n_current_wday++) {
        if (dt_current_day.getDate() == this.dt_current.getDate() &&
          dt_current_day.getMonth() == this.dt_current.getMonth())
          // print current date
          str_buffer += '<TD BGCOLOR="#A4CFEF" ALIGN="center">';
        else if (dt_current_day.getDay() == 0 || dt_current_day.getDay() == 6)
               // weekend days
               str_buffer += '<TD BGCOLOR="#FFFFCC" ALIGN="center">';
             else
               // print working days of current month
               str_buffer += '<TD BGCOLOR="#FFFFFF" ALIGN="center">';

             if (dt_current_day.getMonth() == this.dt_current.getMonth())
               // print days of current month
               str_buffer += '<A HREF="javascript:set_datetime('+dt_current_day.valueOf()+', true)" CLASS="TextSchwarz">';
             else 
               // print days of other months
               str_buffer += '<A HREF="javascript:set_datetime('+dt_current_day.valueOf()+', true)" CLASS="TextGrau">';

               str_buffer += dt_current_day.getDate()+'</A></TD>';
               dt_current_day.setDate(dt_current_day.getDate()+1);
      }
	  // print row footer
	  str_buffer += '</TR>';
	}
	// print calendar footer
    str_buffer += '</TABLE></TR></TD></TABLE></BODY></HTML>';

	obj_calwindow.document.write(str_buffer);
	obj_calwindow.document.close();
	obj_calwindow.focus();
}

// datetime generating function
function cal_gen_date1 (dt_datetime) {
	return (
		new String (
			(dt_datetime.getDate() < 10 ? '0' : '') + dt_datetime.getDate() + "."
			+ (dt_datetime.getMonth() < 9 ? '0' : '') + (dt_datetime.getMonth() + 1) + "."
			+ dt_datetime.getFullYear()
		)
	);
}

// datetime parsing function
function cal_prs_date1 (str_datetime) {

	// if positive integer treat as milliseconds from epoch
	var re_num = /^\d+$/;
	if (re_num.exec(str_datetime))
		return (new Date(str_datetime));
		
	// else treat as date in string format
	var re_date = /^(\d+)\.(\d+)\.(\d+)/;
	if (re_date.exec(str_datetime)) {
      var n_year = Number(RegExp.$3);
      if (n_year < 100)
		n_year += 2000;
		return (new Date (n_year, RegExp.$2-1, RegExp.$1));
	}
    return (new Date());
}


