<?php

function check_search_exp($search_exp) {
  $forbidden_chars = array("/","\"","\\","..","'","<",">","(",")","=","*",";");
  $forbidden_words = array("DELETE","SELECT","UPDATE","ALTER","INSERT","CREATE","DROP","GRANT");
  foreach ($forbidden_chars as $value) {
    if (stristr($search_exp, $value)) return true;
  }
  foreach ($forbidden_words as $value) {
    if (stristr($search_exp, $value)) return true;
  }
  return false;
}

function get_job($job_id,$parsing,$search_exp) {
  $sql_strg = "SELECT jm_job.*,jm_region.*,jm_group.*,jm_category.* FROM jm_job,jm_category,jm_group LEFT JOIN jm_region ON jm_job.region_id = jm_region.id WHERE jm_job.rubrik_id = jm_category.id AND jm_job.job_id = '".$job_id."';";
  //echo $sql_strg."<BR>";
  $db_query_obj = new DB_connect;
  if (! $db_query_obj->db_error) {
    $db_query_obj->db_query($sql_strg);
    if (! $db_query_obj->db_error) {
      $data_array = $db_query_obj->db_fetch_array();
	  if (JOB_LOGGING) { log_job($data_array,$db_query_obj); }
    }
  }
  $db_query_obj->db_close();

  if (! $db_query_obj->db_error) {
    if ($parsing) {
      $data_array["intro"] = preg_replace ("/(".$search_exp.")/i", "<SPAN CLASS='SearchExpMarker'>\\1</SPAN>", $data_array["intro"]);
      $data_array["bezeichnung"] = preg_replace ("/(".$search_exp.")/i", "<SPAN CLASS='SearchExpMarker'>\\1</SPAN>", $data_array["bezeichnung"]);
      $data_array["zusatz"] = preg_replace ("/(".$search_exp.")/i", "<SPAN CLASS='SearchExpMarker'>\\1</SPAN>", $data_array["zusatz"]);
      $data_array["beschreibung"] = preg_replace ("/(".$search_exp.")/i", "<SPAN CLASS='SearchExpMarker'>\\1</SPAN>", $data_array["beschreibung"]);
    }
    define ('JOB_ID', $data_array["job_id"]);
    //define ('JOB_CATEGORY_ID', $data_array["rubrik_id"]);
    //define ('JOB_GROUP_ID', $data_array["gruppe_id"]);
    //define ('JOB_REGION_ID', $data_array["region_id"]);
    define ('JOB_INT_JOBNR', $data_array["int_jobnr"]);
    define ('JOB_CATEGORY',$data_array["rubrik"]);
    define ('JOB_GROUP',$data_array["gruppe"]);
    define ('JOB_REGION',$data_array["region"]);
    define ('JOB_INTRO', $data_array["intro"]);
    define ('JOB_NAME', $data_array["bezeichnung"]);
    define ('JOB_NAME_SUPPLEMENT', $data_array["zusatz"]);

    $data_array["beschreibung"] = preg_replace ("/\r?\n/", "<BR>\n", $data_array["beschreibung"]);
    $data_array["beschreibung"] = preg_replace ("/(<\/?UL>.*)<BR>\n/i", "\\1\n", $data_array["beschreibung"]);
    $data_array["beschreibung"] = preg_replace ("/(<\/?LI>.*)<BR>\n/i", "\\1\n", $data_array["beschreibung"]);
    $data_array["beschreibung"] = preg_replace ("/(<\/?BLOCKQUOTE.*)<BR>\n/i", "\\1\n", $data_array["beschreibung"]);
    define ('JOB_SPECIFICATION', $data_array["beschreibung"]);
    return true;
  } else {
      return false;
    }
}

function make_joblist($db_query_obj, $search_flag, $search_exp) {
  global $list_config_array;
  $char_array = array();
  $list_row_array = array();
  $lfn_count = 0;
  $chr_prev = "";
  $row_count = 0;
  while ($zeile = $db_query_obj->db_fetch_array()) {
    // Laufende Nummer
    if (isset ($list_config_array["lfn_nr"])) {
      $list_row_array[$row_count][$list_config_array["lfn_nr"]["index"]] = ++$lfn_count;
    }
    // Bezeichnung
    if (isset ($list_config_array["bezeichnung"])) {
      if (substr($zeile["bezeichnung"],0,1) != $chr_prev) { 
        array_push($char_array,substr($zeile["bezeichnung"],0,1));
        $chr_prev = substr($zeile["bezeichnung"],0,1);
        if (isset ($list_config_array["lfn_nr"])) {
          $list_row_array[$row_count][$list_config_array["lfn_nr"]["index"]] = "<A NAME='".substr($zeile["bezeichnung"],0,1)."'>".$list_row_array[$row_count][$list_config_array["lfn_nr"]["index"]].".</A>";
        }
      }
      $list_row_array[$row_count][$list_config_array["bezeichnung"]["index"]] = $zeile["bezeichnung"];
      if ($list_config_array["bezeichnung"]["link"] != "") {
        $list_row_array[$row_count][$list_config_array["bezeichnung"]["index"]] = make_joblink($list_row_array[$row_count][$list_config_array["bezeichnung"]["index"]],$list_config_array["bezeichnung"]["link"],$zeile,$search_flag,$search_exp);
      }
    }
    // Rubrik
    if (isset ($list_config_array["rubrik_id"])) {
      $list_row_array[$row_count][$list_config_array["rubrik_id"]["index"]] .= $zeile["rubrik"];
      if ($list_config_array["rubrik_id"]["link"] != "none") {
        $list_row_array[$row_count][$list_config_array["rubrik_id"]["index"]] = make_joblink($list_row_array[$row_count][$list_config_array["rubrik_id"]["index"]],$list_config_array["rubrik_id"]["link"],$zeile,$search_flag,$search_exp);
      }
    }
    // Gruppe
    if (isset ($list_config_array["gruppe_id"])) {
      $list_row_array[$row_count][$list_config_array["gruppe_id"]["index"]] .= $zeile["gruppe"];
      if ($list_config_array["gruppe_id"]["link"] != "none") {
        $list_row_array[$row_count][$list_config_array["gruppe_id"]["index"]] = make_joblink($list_row_array[$row_count][$list_config_array["gruppe_id"]["index"]],$list_config_array["gruppe_id"]["link"],$zeile,$search_flag,$search_exp);
      }
    }
    // interne Jobnummer
    if (isset ($list_config_array["int_jobnr"])) {
      $list_row_array[$row_count][$list_config_array["int_jobnr"]["index"]] .= $zeile["int_jobnr"];
      if ($list_config_array["int_jobnr"]["link"] != "none") {
        $list_row_array[$row_count][$list_config_array["int_jobnr"]["index"]] = make_joblink($list_row_array[$row_count][$list_config_array["int_jobnr"]["index"]],$list_config_array["int_jobnr"]["link"],$zeile,$search_flag,$search_exp);
      }
    }
    // Erstellungsdatum
    if (isset ($list_config_array["erstellt"])) {
      $list_row_array[$row_count][$list_config_array["erstellt"]["index"]] .= datum_konv($zeile["erstellt"],"html");
      if ($list_config_array["erstellt"]["link"] != "none") {
        $list_row_array[$row_count][$list_config_array["erstellt"]["index"]] = make_joblink($list_row_array[$row_count][$list_config_array["erstellt"]["index"]],$list_config_array["erstellt"]["link"],$zeile,$search_flag,$search_exp);
      }
    }
    // Region
    if (isset ($list_config_array["region_id"])) {
      if ($zeile["region"] != "") {
        $list_row_array[$row_count][$list_config_array["region_id"]["index"]] .= $zeile["region"];
      } else {
          $list_row_array[$row_count][$list_config_array["region_id"]["index"]] .= "keine Angabe";
        }
      if ($list_config_array["region_id"]["link"] != "none") {
        $list_row_array[$row_count][$list_config_array["region_id"]["index"]] = make_joblink($list_row_array[$row_count][$list_config_array["region_id"]["index"]],$list_config_array["region_id"]["link"],$zeile,$search_flag,$search_exp);
      }
    }
    ++$row_count;
  }
  $output_strg = layout_fill($list_row_array,$search_flag,$search_exp);
  return $output_strg;
}

function make_joblink($link_text,$link_type,$data_array,$search_flag,$search_exp) {
  global $list_type, $list_type_id;
  switch ($link_type) {
    case "job":
      $link_complete = "<A HREF='jm_jobview_3.php?list_type=".$list_type."&job_id=".$data_array["job_id"];
      if (isset($list_type_id)) { $link_complete .= "&list_type_id=".$list_type_id; }
      if ($search_flag) { $link_complete .= "&parsing=true&search_exp=".$search_exp; }
      $link_complete .= "' CLASS='JobListRowText'>".$link_text."</A>";
      break;
    case "category":
      $link_complete = "<A HREF='job_view_2.php?list_type=category&list_type_id=".$data_array["rubrik_id"]."' CLASS='JobListRowText'>".$link_text."</A>";
      break;
    case "group":
      $link_complete = "<A HREF='job_view_2.php?list_type=group&list_type_id=".$data_array["gruppe_id"]."' CLASS='JobListRowText'>".$link_text."</A>";
      break;
    case "region":
      $link_complete = "<A HREF='job_view_2.php?list_type=region&list_type_id=".$data_array["region_id"]."' CLASS='JobListRowText'>".$link_text."</A>";
      break;
    default:
      $link_complete = $link_text;
  }
  return $link_complete;
}

function layout_fill($list_row_array,$search_flag,$search_exp) {
  global $table_header_array, $list_type, $list_type_id;
  if (! $search_flag) {
    $querystring_part = "list_type=".$list_type."&list_type_id=".$list_type_id;
  } else {
      $querystring_part = "list_type=".$list_type."&list_type_id=".$list_type_id."&search_exp=".$search_exp;
    }
  $output_strg = "<TABLE CELLPADDING='0' CELLSPACING='0' BORDER='0' BGCOLOR='".TABLEBORDER_CONTENT."' WIDTH='100%'>\n<TR><TD><TABLE CELLPADDING='3' CELLSPACING='1' BORDER='0' WIDTH='100%'>\n<TR BGCOLOR='".TABLEBACKGROUND_CONTENT."' VALIGN='bottom'>\n";
  for ($i = 0; $i < count($table_header_array); $i++) {
    if ($table_header_array[$i]["sort_style"] == "asc") {
      $sort_icon = "<IMG SRC='/jobmanager/images/icon_sort_desc.gif' WIDTH='13' HEIGHT='15' BORDER='0'>";
    } else {
        $sort_icon = "<IMG SRC='/jobmanager/images/icon_sort_asc.gif' WIDTH='13' HEIGHT='15' BORDER='0'>";
      }
    $output_strg .= "<TD CLASS='JobListTableHeader'>";
    if ($i != 0) {
      $output_strg .= "<A HREF='jm_jobview_2.php?".$querystring_part."&sort_type=".$table_header_array[$i]["sort_type"]."&sort_style=".$table_header_array[$i]["sort_style"]."' CLASS='JobListTableHeader'>".$table_header_array[$i]["text"]."&nbsp;&nbsp;".$sort_icon."</A>";
    } else {
        $output_strg .= $table_header_array[$i]["text"];
      }
    $output_strg .= "</TD>";
  }
  $output_strg .= "</TR>\n";
  for ($i = 0; $i < count($list_row_array); ++$i) {
    $output_strg .= "<TR BGCOLOR='".TABLEBACKGROUND_CONTENT."' VALIGN='top'>\n";
    for ($j = 0; $j < count($list_row_array[$i]); ++$j) {
      $output_strg .= "<TD CLASS='JobListRowText'>".$list_row_array[$i][$j]."</TD>\n";
    }
    $output_strg .= "</TR>\n";
  }
  $output_strg .= "</TABLE>\n</TD></TR></TABLE><BR><BR>\n";
  return $output_strg;
}

function get_list_sort_order($sort_type) {
  switch ($sort_type) {
  case "bezeichnung":
    $sort_type = "job";
    break;
  case "rubrik_id":
    $sort_type = "category";
    break;
  case "region_id":
    $sort_type = "region";
    break;
  case "gruppe_id":
    $sort_type = "group";
    break;
  case "erstellt":
    $sort_type = "date";
    break;
  case "int_jobnr":
    $sort_type = "jobno";
    break;
  default:
    $sort_type = "job";
  }
  return $sort_type;
}


class Content_header {

  var $ch_head_prefix;
  var $ch_output;

  function Content_header($ch_list_type = Null) {
    $this->ch_output = "";
    switch ($ch_list_type) {
      case "search":
        $this->ch_head_prefix = "Suchergebnis";
        break;
      case "region":
        $this->ch_head_prefix = "Region";
        break;
      case "group":
        $this->ch_head_prefix = "Gruppe";
        break;
      default:
        $this->ch_head_prefix = "Rubrik";
        break;
    }
  }

  function get_output_strg_search($ch_search_exp) {
    $this->ch_output .= "<SPAN CLASS='HeadSchwarzBig'>".$this->ch_head_prefix."</SPAN>\n<BR><BR><SPAN CLASS='TextSchwarzFett'>Suchtext: </SPAN><SPAN CLASS='TextSchwarz'> ".htmlspecialchars($ch_search_exp)."</SPAN><BR>";
  }

  function get_output_strg_nosearch($ch_list_type_name) {
    $this->ch_output .= "<SPAN CLASS='HeadSchwarzBig'>".$this->ch_head_prefix.": ".$ch_list_type_name."</SPAN>";
  }

  function get_output_strg_result_nr($ch_result_nr) {
    if ($ch_result_nr == 0) {
      $this->ch_output .= "<P CLASS='TextSchwarz'>Es konnte kein passender Datensatz zu Ihrer Anfrage gefunden.</P>\n";
    } else {
        $this->ch_output .= "<P CLASS='TextSchwarz'>Es wurden ".$ch_result_nr." Stellenangebote gefunden.</P>\n";
      }
  }

  function get_output_strg_global_error() {
    $this->ch_output .= "<BR><SPAN CLASS='TextSchwarz'>Diese Seite wurde mit falschen Optionen aufgerufen oder die verwendeten Suchworte enthalten unzulssige Zeichen.  Bitte verwenden Sie bei der Suche nur folgende Zeichen: 'A-Z', 'a-z', '1-9', Minus und Leerzeichen.</SPAN><BR>\n";
  }

  function get_output_strg_jobview($ch_list_type) {
    switch ($ch_list_type) {
      case "region":
        $ch_list_type_name = JOB_REGION;
        break;
      case "group":
        $ch_list_type_name = JOB_GROUP;
        break;
      default:
        $ch_list_type_name = JOB_CATEGORY;
        break;
    }
    $this->ch_output .= "<SPAN CLASS='HeadSchwarzBig'>".$this->ch_head_prefix.": ".$ch_list_type_name." - Stellenangebot</SPAN><BR><BR>";
  }

} // End Class Content_header

function make_block_rubrik_list($rubrik_array) {
  $rubrik_list_str = "<IMG SRC='/images/leer.gif' WIDTH='5' HEIGHT='15' BORDER='0'><BR CLEAR='all'>
<TABLE BORDER='0' CELLPADDING='0' CELLSPACING='0' WIDTH='100%' BGCOLOR='#EEEEEE'>
<TR VALIGN='top' BGCOLOR='#02DE02'>
  <TD WIDTH='5'><IMG SRC='/images/leer.gif' WIDTH='5' HEIGHT='1' BORDER='0'></TD>
  <TD COLSPAN='2' CLASS='TextWeissFett'>Rubrikliste</TD>
  <TD WIDTH='5'><IMG SRC='/images/leer.gif' WIDTH='5' HEIGHT='1' BORDER='0'></TD>
</TR>
<TR><TD COLSPAN='4'><IMG SRC='/images/leer.gif' WIDTH='5' HEIGHT='5' BORDER='0'></TD></TR>\n";
 for ($i=0; $i<count($rubrik_array); $i++) {
    $rubrik_list_str .= "<TR VALIGN='top'>\n  <TD WIDTH='5'>&nbsp;</TD>\n  <TD WIDTH='15'><IMG SRC='/images/icon_bewerben.gif' WIDTH='13' HEIGHT='15' BORDER='0'></TD>\n  <TD><A HREF='#".$rubrik_array[$i]."' CLASS='TextSchwarz'>".$rubrik_array[$i]."</A></TD>\n  <TD WIDTH='5'>&nbsp;</TD>\n</TR>\n";
 }
 $rubrik_list_str .= "<TR><TD COLSPAN='4'><IMG SRC='/images/leer.gif' WIDTH='5' HEIGHT='5' BORDER='0'></TD></TR>
 <TR><TD COLSPAN='4' BGCOLOR='#02DE02'><IMG SRC='/images/leer.gif' WIDTH='5' HEIGHT='1' BORDER='0'></TD></TR>
 </TABLE>\n";
 return $rubrik_list_str;
}

function make_block_char_list($char_array) {
  $i = 1;
  $char_list_str = "<IMG SRC='/images/leer.gif' WIDTH='5' HEIGHT='15' BORDER='0'><BR CLEAR='all'>
<TABLE BORDER='0' CELLPADDING='0' CELLSPACING='0' WIDTH='100%' BGCOLOR='#EEEEEE'>
<TR VALIGN='top' BGCOLOR='#02DE02'>
  <TD WIDTH='5'><IMG SRC='/images/leer.gif' WIDTH='5' HEIGHT='1'></TD>
  <TD CLASS='TextWeissFett'>Buchstaben</TD>
  <TD WIDTH='5'><IMG SRC='/images/leer.gif' WIDTH='5' HEIGHT='1'></TD>
</TR>
<TR><TD COLSPAN='3'><IMG SRC='/images/leer.gif' WIDTH='1' HEIGHT='5'></TD></TR>
<TR>
  <TD></TD>
  <TD CLASS='TextSchwarz' BGCOLOR='#02DE02'>
    <TABLE BORDER='0' CELLPADDING='0' CELLSPACING='1' WIDTH='100%'>\n";
  while (list ($key,$value) = each ($char_array)) {
   if ($i == 1) { $char_list_str .= "    <TR>\n"; }
   $char_list_str .= "      <TD BGCOLOR='#FFFFFF' ALIGN='center'>&nbsp;<A HREF='#".$value."' CLASS='TextSchwarzFett'>".$value."</A>&nbsp;</TD>\n";
   if ($i == 5) { 
     $char_list_str .= "    </TR>\n";
     $i = 1;
   } else {
       ++$i;
     }
  }
  if (($i != 5) && ($i != 1 )) {
    $char_list_str .= "      <TD COLSPAN='".(5-$i+1)."' BGCOLOR='#FFFFFF' ALIGN='center' CLASS='TextSchwarz'>&nbsp;</TD>\n    </TR>\n";
  }
  $char_list_str .= "    </TABLE>
  </TD>
  <TD>&nbsp;</TD>
</TR>
<TR><TD COLSPAN='3'><IMG SRC='/jobmanager/images/leer.gif' WIDTH='1' HEIGHT='5'></TD></TR>
<TR BGCOLOR='#02DE02'><TD COLSPAN='3'><IMG SRC='/jobmanager/images/leer.gif' WIDTH='1' HEIGHT='1'></TD></TR>
</TABLE>\n";
  return $char_list_str;
}

function makeBackLink($viewSite) {
  global $list_type, $list_type_id, $search_exp;
  $back_link_str = "<IMG SRC='/jobmanager/images/leer.gif' WIDTH='1' HEIGHT='15'><BR CLEAR='all'>\n<TABLE BORDER='0' CELLPADDING='0' CELLSPACING='0'>\n<TR VALIGN='top'>\n  <TD WIDTH='5'><IMG SRC='/jobmanager/images/leer.gif' WIDTH='5' HEIGHT='1'></TD>\n  <TD WIDTH='15'><IMG SRC='/jobmanager/images/".LIST_BULLET."' BORDER='0'></TD>\n";
 if ($viewSite == 2) {
   $back_link_str .= "<TD><A HREF='jm_jobview_1.php?list_type=".$list_type."' CLASS='TextBacklink'>";
 } elseif ($viewSite == 3) {
         if ($list_type == "search") {
           $back_link_str .= "<TD><A HREF='jm_jobview_2.php?list_type=".$list_type."&search_exp=".$search_exp."' CLASS='TextBacklink'>";
         } else {
             $back_link_str .= "<TD><A HREF='jm_jobview_2.php?list_type=".$list_type."&list_type_id=".$list_type_id."' CLASS='TextBacklink'>";
           }
   }
  $back_link_str .= TEXT_BACKLINK."</A></TD>\n      <TD WIDTH='5'><IMG SRC='/jobmanager/images/leer.gif' WIDTH='5' HEIGHT='1'></TD>\n    </TR>\n    </TABLE>\n";
 if (isset($list_type)) { 
   define ('BACKLINK', $back_link_str);
 } else {
     define ('BACKLINK', '');
   }
}

function log_job($data_array,$query_obj) {
  if ($data_array["region_id"] == "") {
    $data_array["region_id"] = "NULL";
  } else {
     $data_array["region_id"] = "'".$data_array["region_id"]."'";
    }
  if ($data_array["region"] == "") {
    $data_array["region"] = "NULL";
  } else {
     $data_array["region"] = "'".$data_array["region"]."'";
    }
  if ($data_array["int_jobnr"] == "") {
    $data_array["int_jobnr"] = "NULL";
  } else {
     $data_array["int_jobnr"] = "'".$data_array["int_jobnr"]."'";
    }
  $sql_strg = "INSERT INTO jm_jobstats SET job_id='".$data_array["job_id"]."',job_int_nr=".$data_array["int_jobnr"].",  job_name='".$data_array["bezeichnung"]."', category_id='".$data_array["rubrik_id"]."', category_name='".$data_array["rubrik"]."', group_id='".$data_array["gruppe_id"]."', group_name='".$data_array["gruppe"]."', region_id=".$data_array["region_id"].", region_name=".$data_array["region"].", date='".date ("YmdHis",mktime ())."';";
  //echo $sql_strg."<BR>";
  $query_obj->db_query($sql_strg);
}

?>
