<?php
include("includes/config_jobmanager_inc.php");
include("includes/jm_jobview_lib.php");
include("includes/jm_database_class.php");
include("includes/jm_lib.php");
include("includes/jm_layout_config.php");

$output_strg = "";
$back_link_str = "";
$search_option = "";
$search_flag = false;
$global_error = false;
getPostGetVars();

switch ($list_type) {
  case "search":
    $sql_record_identifier = "jm_category.id=jm_job.rubrik_id AND jm_group.id=jm_job.gruppe_id";
    $sql_search_option = "AND ((jm_job.bezeichnung LIKE '%".$search_exp."%') OR (jm_job.beschreibung LIKE '%".$search_exp."%') OR (jm_job.zusatz LIKE '%".$search_exp."%') OR (jm_job.intro LIKE '%".$search_exp."%'))";
    $search_flag = true;
    $global_error = check_search_exp($search_exp);
    break;
  case "region":
    $list_type = "region";
    $sql_name_query_strg = "SELECT region FROM jm_region WHERE id=".$list_type_id.";";
    $sql_record_identifier = "jm_region.id='".$list_type_id."' AND jm_category.id=jm_job.rubrik_id AND jm_group.id=jm_job.gruppe_id";
    break;
  case "group":
    $list_type = "group";
    $sql_name_query_strg = "SELECT gruppe FROM jm_group WHERE id=".$list_type_id.";";
    $sql_record_identifier = "jm_group.id='".$list_type_id."' AND jm_category.id=jm_job.rubrik_id AND jm_group.id=jm_job.gruppe_id";
    break;
  default:
    $list_type = "category";
    $sql_name_query_strg = "SELECT rubrik FROM jm_category WHERE id=".$list_type_id.";";
    $sql_record_identifier = "jm_category.id='".$list_type_id."' AND jm_category.id=jm_job.rubrik_id AND jm_group.id=jm_job.gruppe_id";
}

switch ($sort_type) {
  case "jobno":     // Sortierung nach interner Jobnummer
    $sql_sort_type = "jm_job.int_jobnr";
    break;
  case "category":  // Sortierung nach Job-Bezeichnung
    $sql_sort_type = "jm_category.rubrik";
    break;
  case "region":    // Sortierung nach Region
    $sql_sort_type = "jm_region.region";
    break;
  case "group":     // Sortierung nach Gruppe
    $sql_sort_type = "jm_group.gruppe";
    break;
  case "date":      // Sortierung nach Erstellungdatum
    $sql_sort_type = "jm_job.erstellt";
    break;
  case "job":      // Sortierung nach Erstellungdatum
    $sql_sort_type = "jm_job.bezeichnung";
    break;
  default:          // Sortierung nach Job-Bezeichnung
    $sql_sort_type = "jm_job.bezeichnung";
}

switch ($sort_style) {
  case "asc":     // Aufsteigende Sortierung
    $sql_sort_type .= " ASC";
    $sort_style = "desc";
    break;
  case "desc":   // Absteigende Sortierung
    $sql_sort_type .= " DESC";
    $sort_style = "asc";
    break;
  default:       // Default-Sortierung (Aufsteigend)
    $sql_sort_type .= " ASC";
    $sort_style = "desc";
}

$sql_strg = "SELECT jm_job.*,jm_region.*,jm_category.*,jm_group.* FROM jm_job,jm_category,jm_group LEFT JOIN jm_region ON jm_job.region_id = jm_region.id WHERE ".$sql_record_identifier." AND ((jm_job.guelab <= CURRENT_DATE AND jm_job.guelbis >= CURRENT_DATE) OR (jm_job.guelab <= CURRENT_DATE AND jm_job.guelbis = '0000-00-00') OR (jm_job.guelab = '0000-00-00' AND jm_job.guelbis >= CURRENT_DATE) OR (jm_job.guelab = '0000-00-00' AND jm_job.guelbis = '0000-00-00')) AND jm_job.publish = 'y' ".$sql_search_option." ORDER BY ".$sql_sort_type.";";

if (! $global_error) {
  $db_query_obj = new DB_connect;
  list($list_config_array, $table_header_array) = get_list_config($list_type, $db_query_obj);
  if (! $search_flag) {
    $db_query_obj->db_query($sql_name_query_strg);
    $db_query_result = $db_query_obj->db_fetch_array();
  }
  $db_query_obj->db_query($sql_strg);
  $result_nr = $db_query_obj->db_num_rows();
  $content_header = new Content_header($list_type);
  if ($search_flag) {
    $content_header->get_output_strg_search($search_exp);
  } else {
      $content_header->get_output_strg_nosearch($db_query_result[0]);
    }
  $content_header->get_output_strg_result_nr($result_nr);
  if ($result_nr != 0) { $output_strg = make_joblist($db_query_obj, $search_flag, $search_exp); }
  $db_query_obj->db_close();
} else {
    $content_header = new Content_header($list_type);
    if ($search_flag) {
      $content_header->get_output_strg_search($search_exp);
    } else {
        $content_header->get_output_strg_nosearch($db_query_result[0]);
      }
    $content_header->get_output_strg_global_error();
  }

define ('CONTENT_HEADER', $content_header->ch_output);
makeBackLink("2");


function get_list_config($list_type,$db_query_obj) {
  global $sort_style,$sort_type;
  $db_query_obj->db_query("SELECT * FROM jm_list_config WHERE list_name='".$list_type."';");
  $list_config_array = $db_query_obj->db_fetch_array();
  $db_query_obj->db_query("SELECT * FROM jm_list_config_fields;");
  while ($zeile = $db_query_obj->db_fetch_assoc()) {
    $list_config_fields_array[$zeile["id"]] = $zeile;
  }
  $db_query_obj->db_query("SELECT * FROM jm_list_config_links;");
  while ($zeile = $db_query_obj->db_fetch_assoc()) {
    $list_config_links_array[$zeile["id"]] = $zeile;
  }
  $j = 0;
  for ($i = 1; $i <= 7; $i++) {
    if (!empty ($list_config_array["row_".$i."_show"])) {
      $table_header_array[$j]["text"] = $list_config_fields_array[$list_config_array["row_".$i."_show"]]["text_de"];

      $table_header_array[$j]["sort_type"] = get_list_sort_order($list_config_fields_array[$list_config_array["row_".$i."_show"]]["db_field_name"]);
      if ($table_header_array[$j]["sort_type"] == $sort_type) { 
        $table_header_array[$j]["sort_style"] = $sort_style;
      } else {
          $table_header_array[$j]["sort_style"] = "desc";
        }

      $table_row_config_array[$list_config_fields_array[$list_config_array["row_".$i."_show"]]["db_field_name"]] = array("index"=>$j, "link"=>$list_config_links_array[$list_config_array["row_".$i."_link"]]["link_name"]);
      ++$j;
    }
  }
  return array($table_row_config_array, $table_header_array);
}

if (! $db_query_obj->db_error) {
  include(DIR_TEMPLATE_FILES.TEMPLATE_JOBVIEW_2);
} else {
    include(DIR_TEMPLATE_FILES.TEMPLATE_JOBVIEW_ERROR);
  }
?>
